﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.IO;
using phX.Framework;

namespace phX.Parts
{
    public class _08_Wall
    {
        public _08_Wall()
        {
            try
            {
                WriteWall(  Program.ToDataFolder("08_Wall/Wall.png"),
                            Program.ToZ80Folder("08_Wall/_Wall.bin"));
            }
            catch (Exception e)
            {
                Log.Fatal(e.ToString());
            }
        }

        private void WriteWall(string srcImage, string dstZ80)
        {
            var bitmap = new Bitmap(srcImage);
            var image = Framework.Image.CreateImage(new Framework.Image.CreateImageStruct
                {
                    Bitmap = bitmap,
                    Mode = 0,
                    R1 = 48,
                    R4 = 38 + 39,
                    R9 = 2,
                    StartVLC = 0,
                    FirstPixelInPaletteX = 0,
                    FirstPixelInPaletteY = 0
                }
            );

            foreach (var VLC in image.Pages[0].VLCs)
            {
                File.WriteAllBytes(dstZ80 + ".vlc" + VLC.Index, VLC.CPCBytes);
            }

            File.WriteAllText(dstZ80+".pal.z80",image.Palette.ToZ80TableString(Program.FilenameToKeyWordName(dstZ80)));
        }
    }
}
