﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using System.Diagnostics;

namespace phX.Framework
{
    public class BBPacker
    {
        public static byte[] Pack(ref byte[] inBytes)
        {
            var debugDir = Program.GetRootDirectory() + "VS2015\\phx\\bin\\Debug\\";

            var filename = debugDir + "\\TempPack_" + Guid.NewGuid() + ".bin";
            File.WriteAllBytes(filename, inBytes);

            StartProcess(debugDir, debugDir + "\\ThirdParty\\BitBuster.exe", "\"" + filename + "\"");

            var packedFilename = filename + ".pck";
            var outBytes = File.ReadAllBytes(packedFilename);

            File.Delete(packedFilename);
            File.Delete(filename);

            var finalSize = outBytes.Length - 4;
            return new List<byte>(outBytes).Skip(4).Take(finalSize).ToArray();
        }

        private static bool StartProcess(string workingDirectory, string filename, string arguments)
        {
            ProcessStartInfo startInfo = new ProcessStartInfo();
            startInfo.CreateNoWindow = true;
            startInfo.UseShellExecute = false;
            startInfo.WorkingDirectory = workingDirectory;
            startInfo.FileName = filename;
            startInfo.Arguments = arguments;
            try
            {
                using (Process exeProcess = Process.Start(startInfo))
                {
                    exeProcess.WaitForExit();
                }
            }
            catch (Exception e)
            {
                throw e;
            }

            return true;
        }
    }
}
