using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace phX.Framework
{
	public class Sprite
	{
		public Palette Palette;

		public int ByteWidth;
		public int Height;

		public byte[] CPCBytes;
		
		//--
		public static Sprite ConvertToSprite(Bitmap bitmap, int mode, Palette palette)
        {
            var sprite = new Sprite();

            if (palette == null)
            {
                palette = new Palette();
            }

            var cpcBytes = new List<byte>();

            for (int y = 0; y < bitmap.Height; y++)
            {
                var line = Pixel.ToPixels(bitmap, mode, y, ref palette);

                sprite.ByteWidth = line.Length;

                cpcBytes.AddRange(line);
            }

            sprite.CPCBytes = cpcBytes.ToArray();
            sprite.Height = bitmap.Height;
            sprite.Palette = palette;

            return sprite;
        }
	}
}
		
		