﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.IO;
using phX.Framework;
using System.Drawing.Imaging;

namespace phX.Parts
{
    public class _14_DistoScroll
    {
        private const int ScreenHeight = 268;
        //private const int PrivateSectionSize = 5 + 2 + 1; // 5=VLC R0 values + 2=Special cases + 1=hidden line
        private const int NbUniqueLines = 249;
        private const int NbAnimFrames = 48;

        public _14_DistoScroll()
        {
            try
            {
                CreateFont(
                    Program.ToDataFolder("14_DistoScroll/Font16x32.png"),
                    Program.ToZ80Folder("14_DistoScroll/_FontPalette.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_Font.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_Font2.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_Font3.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_ScrollText.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_ScreenCenter.z80"),
                    "0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ./?\"!'-abcdefghijklmnopqrstuvwxyz0123456789 ABCDEFGHIJKLMNOPQRSTUVWXYZ./?\"!'-()[]+=<*&%$#@>_{}|é^àè",
                    "0           " + // first line is ignored
                    "0           " +
                    "1 YOU HAVE  " +
                    "1 JUST SEEN " +
                    "0           " +
                    "0           " +
                    "0  ()[]+=<  " +
                    "0  *&%$#@_  " +
                    "0  __}|é__  " + 
                    "0           " +
                    "0           " +
                    "1  A DEMO   " +
                    "1RELEASED AT" +
                    "0           " +
                    "0 REVISION  " +
                    "0   2018    " +
                    "0  GERMANY  " +
                    "0           " +
                    "1    BY     " +
                    "0           " +
                    "0abcdefghij " +
                    "0klmnopqrst " +
                    "0uvwxyz     " +
                    "0           " +
                    "0           " +
                    "0           " +
                    "0 CODED BY  " +
                    "1 NORECESS  " +
                    "0  CANADA   " +
                    "1           " +
                    "0  ART BY   " +
                    "1    CED    " +
                    "0  FRANCE   " +
                    "1           " +
                    "0 AUDIO BY  " +
                    "1  FACTOR6  " +
                    "0   CZECH   " +
                    "1           " +
                    "0TRACKLOADER" +
                    "1 ARNOLDEMU " +
                    "0  ENGLAND  " +
                    "0           " +
                    "0           " +
                    "0           " +
                    "0 THIS DEMO " +
                    "0WAS CREATED" +
                    "0  OVER A   " +
                    "0 PERIOD OF " +
                    "0 5 YEARS!  " +
                    "0           " +
                    "1 INCLUDING " +
                    "1  2 YEARS  " +
                    "1OF PRACTICE" +
                    "1 IN VIDEO  " +
                    "1   CHIP    " +
                    "1PROGRAMMING" +
                    "1CREATION OF" +
                    "1 YM PLAYER " +
                    "1DATA PACKER" +
                    "1  ETC...   " +
                    "0           " +
                    "0THIS IS THE" +
                    "0 FRUIT OF  " +
                    "0PASSIONATE " +
                    "0   WORK    " +
                    "0           " +
                    "0           " +
                    "0           " +
                    "1 GREETINGS " +
                    "1    TO     " +
                    "0           " +
                    "0           " +
                    "0   LOGON   " +
                    "0  SYSTEM   " +
                    "0           " +
                    "1EASTER EGG " +
                    "0           " +
                    "0RESISTANCE " +
                    "0           " +
                    "1    THE    " +
                    "1DEADLINERS " +
                    "1           " +
                    "0SECTOR ONE " +
                    "0           " +
                    "1   GEMBA   " +
                    "0           " +
                    "0   H-PRG   " +
                    "0           " +
                    "1 ZEROTEAM  " +
                    "0           " +
                    "0 DEMARCHE  " +
                    "0           " +
                    "1BENEDICTION" +
                    "0           " +
                    "0  BATMAN   " +
                    "0   GROUP   " +
                    "0           " +
                    "1   ARKOS   " +
                    "0           " +
                    "0  VANITY   " +
                    "0           " +
                    "1OVERLANDERS" +
                    "0           " +
                    "0  FUTURS   " +
                    "0           " +
                    "1FLOWER CORP" +
                    "0           " +
                    "0  IMPACT   " +
                    "0           " +
                    "1   DIRTY   " +
                    "1   MINDS   " +
                    "0           " +
                    "0           " +
                    "0           " +
                    "0 CONDENSE  " +
                    "0  HAS NOT  " +
                    "0 RELEASED  " +
                    "0ANYTHING AT" +
                    "0  PARTIES  " +
                    "0  FOR THE  " +
                    "0  LAST 15  " +
                    "0   YEARS   " +
                    "0           " +
                    "1 HOPEFULLY " +
                    "1 THIS HAS  " +
                    "1 NOW BEEN  " +
                    "1  FIXED!   " +
                    "0           " +
                    "0           " +
                    "0           " +
                    "0           " +
                    "08-BIT WILL " +
                    "0 NEVER DIE " +
                    "0           " +
                    "0           " +
                    "0           " +
                    "0           "
                    );

                CreateMappingTable(
                    Program.ToZ80Folder("14_DistoScroll/_MappingTable_WriteValues.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_MappingTable_ValuesPtr.z80")
                    );

                CreateRasterTable(
                    Program.ToDataFolder("14_DistoScroll/BackgroundRasters9.png"),
                    Program.ToZ80Folder("14_DistoScroll/_BackgroundRasters.z80"));

                CreateAnim(
                    Program.ToZ80Folder("14_DistoScroll/_AnimFramesPtr.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_AnimFrames.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_AnimConfig.z80")
                    );

                CreateR12R13Related(
                    Program.ToZ80Folder("14_DistoScroll/_R12R13_ScreenPtr_0.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_R12R13_ScreenPtr_1.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_R12R13_ScreenPtr_2.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_R12R13_BC00.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_R12R13_BD00.z80"),
                    Program.ToZ80Folder("14_DistoScroll/_R12R13_BE00.z80")
                    );
            }
            catch (Exception e)
            {
                Log.Fatal(e.ToString());
            }
        }

        public class CharacterInfo
        {
            public string ASCII = "";
            public int CharIndex;
            public int ColorIndex;
            public Framework.Image CPCImage;
        }
        private void CreateFont(string fontPng, string fontPaletteZ80, string fontZ80, string font2Z80, string font3Z80, string textZ80, string screenCenterZ80, string charset, string scrollText)
        {
            var baseBitmap = new Bitmap(fontPng);
            var basePalette = new Palette();

            // for OLD_Font16x32.png
            //basePalette.AddColor(baseBitmap.GetPixel(0, 32-1)); // add background as PEN0
            //basePalette.AddColor(baseBitmap.GetPixel(0, 1)); // add BLACK as PEN1
            
            // for Font16x32.png
            //basePalette.AddColor(Color.White); // add background as PEN0
            //basePalette.AddColor(Color.Black); // add BLACK as PEN1

            var tempImage = Framework.Image.CreateImage(new Framework.Image.CreateImageStruct
            {
                Bitmap = baseBitmap,
                Mode = 0,
                R1 = 800,
                R4 = 38,
                R9 = 7,
                StartVLC = 0,
                FirstPixelInPaletteX = 0,
                FirstPixelInPaletteY = 0
                //Palette = basePalette
            });
            basePalette = tempImage.Palette;

            File.WriteAllText(fontPaletteZ80, basePalette.ToZ80TableString(Program.FilenameToKeyWordName("DistoScrollPalette")));

            var chars = new List<CharacterInfo>();
            int indexInCharset = -1;
            foreach(var c in charset)
            {
                indexInCharset++;

                if (!scrollText.Contains(c))
                {
                    continue;
                }

                if(c=='_')
                {
                    continue;
                }
                
                var newChar = new CharacterInfo()
                {
                    ASCII = "" + c,
                    CharIndex = chars.Count,
                    ColorIndex = 0
                };

                if (indexInCharset>50)
                {
                    foreach(var nc in chars)
                    {
                        if(nc.ASCII == ""+c)
                        {
                            newChar.CharIndex = nc.CharIndex;
                            newChar.ColorIndex = 1;
                            break;
                        }
                    }
                }

                var charBitmap = new Bitmap(16, 32);
                for(int y=0; y<32; y++)
                {
                    for (int x = 0; x < 16; x++)
                    {
                        var color = baseBitmap.GetPixel(x + (indexInCharset*16), y);
                        charBitmap.SetPixel(x, y, color);
                    }
                }

                var charImage = Framework.Image.CreateImage(new Framework.Image.CreateImageStruct
                {
                    Bitmap = charBitmap,
                    Mode = 0,
                    R1 = 48,
                    R4 = 38,
                    R9 = 7,
                    StartVLC = 0,
                    FirstPixelInPaletteX = 0,
                    FirstPixelInPaletteY = 0,
                    Palette = basePalette
                });
                newChar.CPCImage = charImage;

                chars.Add(newChar);
            }

            var z80 = "";

            var z80Bytes = new List<byte>();
            int iCount = 0;
            bool isFirstFile = true;
            bool isSecondFile = true;
            bool isFirst;
            foreach (var c in chars)
            {
                z80 += ";\n";
                z80 += "DS_CHAR_" + c.CharIndex + "_" + c.ColorIndex + ": ;; " + c.ASCII + "\n";
                z80 += "\tdb ";

                isFirst = true;
                int bWritten = 0;
                foreach(byte b in c.CPCImage.CPCRawBuffer)
                {
                    if(bWritten==16)
                    {
                        bWritten = 0;
                        isFirst = true;
                        z80 += "\n\tdb ";
                    }
                    if (!isFirst)
                    {
                        z80 += ",";
                    }
                    isFirst = false;

                    z80 += "&" + b.ToString("X2");
                    z80Bytes.Add(b);

                    bWritten++;
                }
                z80 += "\n";

                iCount++;
                if(isFirstFile)
                {
                    if (iCount == 40)
                    {

                        isFirstFile = false;
                        isSecondFile = true;

                        File.WriteAllText(fontZ80, z80);
                        z80 = "";
                        z80Bytes = new List<byte>();
                        iCount = 0;
                    }
                }
                else if (isSecondFile)
                {
                    if (iCount == 38)
                    {
                        isSecondFile = false;

                        File.WriteAllText(font2Z80, z80);
                        z80 = "";
                        z80Bytes = new List<byte>();
                        iCount = 0;
                    }
                }
            }

            File.WriteAllText(font3Z80, z80);
            var rawBin = z80Bytes.ToArray();
            File.WriteAllBytes(font3Z80 + ".bin", rawBin);
            var BBPackedBytes = BBPacker.Pack(ref rawBin);
            File.WriteAllBytes(font3Z80 + ".bin.bbPacked", BBPackedBytes);
            
            int iLine = 0;
            z80 = "";
            int cWritten = 0;
            isFirst = true;
            z80 += "\tdb ";
            int CharCounter = 11;
            foreach (var iC in scrollText)
            {
                char c = iC;
                if (c == '_')
                {
                    c = ' ';
                }

                CharCounter++;
                if(CharCounter==12)
                {
                    CharCounter = 0;
                    iLine = ((int)c) - '0';
                    continue;
                }

                if (cWritten == 11)
                {
                    cWritten = 0;
                    isFirst = true;
                    z80 += "\n\tdb ";
                }
                if (!isFirst)
                {
                    z80 += ", ";
                }
                isFirst = false;

                int charIndex = -1;
                foreach(var cFont in chars)
                {
                    if(cFont.ASCII==""+c)
                    {
                        charIndex = cFont.CharIndex;
                        break;
                    }
                }
                if(charIndex==-1)
                {
                    System.Diagnostics.Debugger.Break();
                }

                int colorIndex = 0;
                if(iLine==1)
                {
                    foreach (var cFont in chars)
                    {
                        if ((cFont.ASCII == "" + c)&&(cFont.ColorIndex==1))
                        {
                            colorIndex = 1;
                            break;
                        }
                    }
                }
                z80 += "DS_CHAR_" + charIndex + "_" + colorIndex + "/256";

                cWritten++;
            }

            File.WriteAllText(textZ80, z80);

            /*
             * 
                    "           " +
                    "  AAAAAAA  " +
                    " BBBBBBBB  " +
                    "CCCCCCCCCC " +
                    "DDDDDDDDDDD" +
                    "           " +
             */

            z80 = ";\n";
            z80 += "DistoScroll_ScreenCenterTable:\n";
            for (iLine=0; iLine < scrollText.Length/12; iLine++)
            {
                string lineText = "";
                for(int i=1; i<12; i++)
                {
                    lineText += scrollText[i + iLine * 12];
                }

                string baseLineText = lineText;

                if (lineText != "           ")
                {
                    lineText = lineText.Trim();
                }

                int lineOffset = 0;
                if((lineText.Length&1)==0)
                {
                    lineOffset = 4;
                }

                z80 += "\tdb " + lineOffset + " ;; \"" + baseLineText + "\"\n";
            }

            File.WriteAllText(screenCenterZ80, z80);
        }

        private void CreateMappingTable(string destWriteValuesZ80, string destValuesPtrZ80)
        {
            var z80 = "";
            z80 += ";\n";
            z80 += "DistoScroll_MappingTable_WriteValues:\n";

            int i;
            for (i = 255; i >= 8; i-=2)
            {
                var v1 = i;
                var v2 = i - 1;

                if(v1==256)
                {
                    v1 = 7;
                }
                if (v2 == 6)
                {
                    v2 = 255;
                }

                z80 += "\tld bc, &" + v1.ToString("X2") + v2.ToString("X2") + " ;; " + v1 + "  " + v2 +"\n";
                z80 += "\tpush bc\n";
            }

            z80 += "DistoScroll_MappingTable_WriteValues_Half:\n";

            for (i = 256; i >= 7; i -= 2)
            {
                var v1 = i;
                var v2 = i - 1;

                if (v1 == 256)
                {
                    v1 = 7;
                }
                if (v2 == 6)
                {
                    v2 = 255;
                }

                z80 += "\tld bc, &" + (v1).ToString("X2") + (v2).ToString("X2") + " ;; " + v1 + "  " + (v2) + "\n";
                z80 += "\tpush bc\n";
            }
            z80 += "\tjp (hl)\n";

            File.WriteAllText(destWriteValuesZ80, z80);

            z80 = "";
            z80 += ";\n";
            z80 += "DistoScroll_MappingTable_ValuesPtr:\n";

            for (i = 0; i < 7; i++)
            {
                //z80 += "\tdw 0 ;; not used\n";
            }
            for (i = 7; i <= 255; i++)
            {
                z80 += "\tdw DistoScroll_MappingTable_WriteValues_Half - " + ((i - 7) * 4) + " ;; value at index 7 =" + i + "\n";
            }

            File.WriteAllText(destValuesPtrZ80, z80);
        }

        private void CreateRasterTable(string imageFilename, string destZ80)
        {
            Bitmap bmp = new Bitmap(System.Drawing.Image.FromFile(imageFilename));

            var z80Content = "";
            z80Content += ";\n";
            // z80Content += "DistoScroll_BackgroundRasters:\n";

            for (int y = 0; y < bmp.Height; y++)
            {
                var pixel = bmp.GetPixel(0, y);

                var palette = new Palette();
                palette.AddColor(pixel);

                var gateArrayColor = palette.ToFirmwareByteArray()[0];

                z80Content += "\tdb 0:db COLOR" + gateArrayColor + "\n";
            }

            File.WriteAllText(destZ80, z80Content);
        }

        private void CreateAnim(string destPtrZ80, string destZ80, string configZ80)
        {
            const int glassHeight = 40;
            const int glassPosY = ScreenHeight / 2 - glassHeight / 2;

            var z80Content = "";

            z80Content += ";\n";
            z80Content += "DISTOSCROLL_NB_FRAMES\tequ " + NbAnimFrames + "\n";
            z80Content += "\n";
            z80Content += ";\n";
            z80Content += "DISTOSCROLL_EXIT_ROUTINE\tequ 5\n";
            z80Content += "DISTOSCROLL_EMPTY_DARK_LINE\tequ 6\n";
            z80Content += "\n";

            int n;
            for (int _iFrame = 0; _iFrame < NbAnimFrames; _iFrame++)
            {
                int iFrame = _iFrame;

                double bitmapHeight = NbUniqueLines-1;

                double frameDelta = bitmapHeight / (double)(NbAnimFrames);
                double yFrame = ((double)iFrame) * frameDelta;

                double progress = (double)iFrame / (double)(NbAnimFrames);
                progress = -1 + (progress * 2); // from -1 to 1
                double sinProgress1 = 1 * Math.PI * (progress);/// 4.0;
                double sinProgress2 = 1 * Math.PI * (progress);/// 4.0;
                double sinProgress3 = 1 * Math.PI * (progress);
                
                z80Content += ";\n";
                z80Content += "DistoScroll_AnimFrame" + _iFrame + ":\n";

                var frameData = new List<int>();
                for (int iY = 0; iY < ScreenHeight; iY++)
                {
                    // debut -- show all lines (scale from 7->254)
                    //int lineIndex = (int)((((float)iY) / (float)ScreenHeight) * (float)(NbUniqueLines-1)); //-1 because last line in FX is used as back buffer

                    // debug -- show only RVI in Page &4000-&5800 
                    /*int lineIndex = iY;
                    while (lineIndex > 21*3)
                    {
                        lineIndex -= 21 * 3;
                    }
                    lineIndex += 21 * 3;*/

                    const int nbMaxMoveLines = 22;

                    // the real anim !
                    var v1 = Math.Sin(sinProgress1);
                    var v2 = Math.Cos(sinProgress2+3);
                    var v3 = Math.Cos(sinProgress3+4+5.21);
                    sinProgress1 -= 0.017f;
                    sinProgress2 -= 0.040f;
                    sinProgress3 += 0.008f;

                    double srcY = 0;
                    srcY += (v1 * (double)(nbMaxMoveLines / 3.5));
                    srcY -= (v2 * (double)(nbMaxMoveLines / 3.5));
                    srcY += (v3 * (double)(nbMaxMoveLines / 3.5));
                    srcY += (double)(nbMaxMoveLines / 2);
                    srcY += (double)((int)((((float)iY) / (float)ScreenHeight) * (float)(NbUniqueLines - 1 - nbMaxMoveLines))); //-1 because last line in FX is used as back buffer);
                    if(srcY<0)
                    {
                        srcY = 0;
                    }
                    if (srcY >= bitmapHeight)
                    {
                        srcY = bitmapHeight;
                    }
                    /*while (srcY < 0)
                    {
                        srcY += bitmapHeight;
                    }
                    while (srcY >= bitmapHeight)
                    {
                        srcY -= bitmapHeight;
                    }*/
                    int lineIndex = (byte)srcY;

                    frameData.Add(lineIndex);                    
                }

                // insert magnifyng glass
                n = iFrame;
                double iAmplitude = 10;
                double iFrequency = 0.5;
                double sinValue = (short)((iAmplitude) * Math.Sin((2 * Math.PI * n * iFrequency) / (double)NbAnimFrames));
                sinValue -= iAmplitude / 2;

                //sinValue = 0;
                //var glassPosY = (int)(((double)(ScreenHeight/2) - glassHeight/2) + sinValue);

                
                //Console.WriteLine("glassPosY="+glassPosY+ "  sinValue="+ sinValue);

                //const int glassPosY = 100;
                var baseData = new List<int>();
                int y;
                for(y=0; y< glassHeight; y++)
                {
                    baseData.Add(frameData[y+glassPosY-glassHeight]);
                }

                var glassData = new List<int>();
                double frequency = 0.5;
                double sampleRate = (double)(glassHeight-1);
                double amplitude = (double)(glassHeight-1);
                for (n=0; n<(glassHeight-1); n++)
                {
                    if(n==0)
                    {
                        continue;
                    }

                    int v1 = (int)(amplitude * Math.Sin((2 * Math.PI * n * frequency) / sampleRate));

                    int i;
                    int v;
                    if (n< glassHeight/2)
                    {
                        i = v1 / 2;
                    }
                    else
                    {
                        i = baseData.Count - v1 / 2;
                    }
                    i = baseData.Count - i;
                    v = baseData[i];
                    glassData.Add(v);

                    //Console.WriteLine("v1=" + v1 + "   i="+i+ "   v="+v);
                }

                y = glassPosY;
                foreach( var v in glassData)
                {
                    //frameData[y] = v;
                    y++;
                }

                // finally inject into Z80
                int j = 0;
                foreach (var lineIndex in frameData)
                {
                    /*if(j==0)
                    {
                        z80Content += "\tdb " + (6) + "\n"; // dark line for 1st line
                    }
                    else*/
                    {
                        z80Content += "\tdb " + (7 + lineIndex) + "\n";
                    }
                    j++;
                }

                z80Content += "\tdb DISTOSCROLL_EXIT_ROUTINE\n";

                z80Content += "\n";
            }

            File.WriteAllText(destZ80, z80Content);

            z80Content = "";
            z80Content += ";\n";
            z80Content += "DistoScroll_AnimFrameTablePtr:\n";
            for(int iFrame = 0; iFrame < NbAnimFrames; iFrame++)
            {
                z80Content += "\tdw DistoScroll_AnimFrame" + iFrame + "\n";
            }
            File.WriteAllText(destPtrZ80, z80Content);

            z80Content = "";
            z80Content += ";\n";
            z80Content += "DistoScroll_GlassHeight\tequ " + glassHeight + "\n";
            z80Content += "DistoScroll_GlassPosY\tequ " + glassPosY + "\n";
            File.WriteAllText(configZ80, z80Content);
        }

        public class R12R13
        {
            public byte R12;
            public byte R13;
            public ushort CPCAddress;
            public byte VLCIndex; // 0..2
            public byte LineIndex; // 0..21
            public byte PageIndex; // 0..3
        }
        private void CreateR12R13Related(   string z80ScreenPtrFilename_0,
                                            string z80ScreenPtrFilename_1,
                                            string z80ScreenPtrFilename_2,
                                            string z80BC00filename,
                                            string z80BD00filename,
                                            string z80BE00filename
                                            )
        {
            var r12r13List = new List<R12R13>();

            for (int iPage = 0; iPage < 4; iPage++)
            {
                for (int iLine = 0; iLine < 21; iLine++)
                {
                    for (int iVLC = 0; iVLC < 3; iVLC++)
                    {
                        ushort CPCAddress = (ushort)((iPage * 0x4000) + (iVLC * 0x800) + (iLine * 96));
                        ushort CRTCOffset = (ushort)(iLine*48);
                        byte overscanBits = (byte)(iPage * 0x10);

                        // discard lines that can't be completely displayed (cf. end of screens)
                        if (CRTCOffset >= (1024-48))
                        {
                            continue;
                        }

                        var r12r13 = new R12R13();
                        r12r13.CPCAddress = CPCAddress;
                        r12r13.R12 = (byte)(overscanBits + ((CRTCOffset) >> 8));
                        r12r13.R13 = (byte)((CRTCOffset) & 255);
                        r12r13.VLCIndex = (byte)(iVLC);
                        r12r13.LineIndex = (byte)(iLine);
                        r12r13.PageIndex = (byte)(iPage);

                        if (r12r13List.Count < 250)
                        {
                            r12r13List.Add(r12r13);
                        }
                    }
                }
            }

            var z80_BC00 = "";
            var z80_BD00 = "";
            var z80_BE00 = "";

            z80_BC00 += "\tdb &00 ;; Offset=5 Exit Routine\n";
            z80_BD00 += "\tdb &00 ;; Offset=5 Exit Routine\n";
            z80_BE00 += "\tdb DistoScroll_FXLine_ExitRoutine_RasterLine0 AND 255 ;; Offset=5 special case\n";

            z80_BC00 += "\tdb &00 ;; Offset=6 Empty Dark Line R12\n";
            z80_BD00 += "\tdb &00 ;; Offset=6 Empty Dark Line R13\n";
            z80_BE00 += "\tdb DistoScroll_FXLine_VLC0_RasterLine0 AND 255 ;; Offset=6 special case\n";

            int iOffset = 7;
            var isFirst = true;
            foreach (var r12r13 in r12r13List)
            {
                // skip first line, cf. exit routine and empty dark lines (1st unique line is used for this)
                if (isFirst)
                {
                    isFirst = false;
                    continue;
                }

                z80_BC00 += "\tdb &" + r12r13.R12.ToString("X2") + " ;; Offset=" + iOffset + " Page=" + r12r13.PageIndex + " Line=" + r12r13.LineIndex + " VLC=" + r12r13.VLCIndex + " ScreenPtr=&" + r12r13.CPCAddress.ToString("X4") + "\n";
                z80_BD00 += "\tdb &" + r12r13.R13.ToString("X2") + " ;; Offset=" + iOffset + " Page=" + r12r13.PageIndex + " Line=" + r12r13.LineIndex + " VLC=" + r12r13.VLCIndex + " ScreenPtr=&" + r12r13.CPCAddress.ToString("X4") + "\n";

                switch (r12r13.VLCIndex)
                {
                    case 0:
                        z80_BE00 += "\tdb DistoScroll_FXLine_VLC0_RasterLine0 AND 255 ;; Offset=" + iOffset + "\n";
                        break;
                    case 1:
                        z80_BE00 += "\tdb DistoScroll_FXLine_VLC1_RasterLine0 AND 255 ;; Offset=" + iOffset + "\n";
                        break;
                    case 2:
                        z80_BE00 += "\tdb DistoScroll_FXLine_VLC2_RasterLine0 AND 255 ;; Offset=" + iOffset + "\n";
                        break;
                }

                iOffset++;
            }

            var z80 = "";
            z80 += ";; &BC00 (R12)\n";
            z80 += "DistoScroll_BC00:\n";
            for (int i = 0; i < 5; i++)
            {
                z80 += "\tdb 0 ;; Offset=" + i + " RVI offset - not used for index translation\n";
            }
            z80 += z80_BC00;
            File.WriteAllText(z80BC00filename, z80);

            z80 = "";
            z80 += "\n";
            z80 += ";; &BD00 (R13)\n";
            z80 += "DistoScroll_BD00:\n";
            for (int i = 0; i < 5; i++)
            {
                z80 += "\tdb 0 ;; Offset=" + i + " RVI offset - not used for index translation\n";
            }
            z80 += z80_BD00;
            z80 += "\n";
            File.WriteAllText(z80BD00filename, z80);

            z80 = "";
            z80 += ";; &BE00 (WishedVLC jump IXL/IYL)\n";
            z80 += "DistoScroll_BE00:\n";
            for (int i = 0; i < 5; i++)
            {
                z80 += "\tdb 0 ;; Offset=" + i + " RVI offset - not used for index translation\n";
            }
            z80 += z80_BE00;
            z80 += "\n";
            File.WriteAllText(z80BE00filename, z80);

            var z80_0 = "";
            var z80_1 = "";
            var z80_2 = "";
            z80_0 += ";\n";
            z80_1 += ";\n";
            z80_2 += ";\n";
            //z80 += "DistoScroll_UniqueLines_ScreenPtr:\n";
            isFirst = true;
            iOffset = 7;
            foreach (var r12r13 in r12r13List)
            {
                // skip 1 first line, cf. exit routine and empty dark lines (1st unique line is used for this)
                if (isFirst)
                {
                    isFirst = false;
                    continue;
                }

                ushort cpcAddress = r12r13.CPCAddress;
                byte cpcBank = 0xC1;

                // >&C000 addresses will be accessed through C3
                if(r12r13.PageIndex==3)
                {
                    cpcAddress = (ushort)(cpcAddress-0x8000);
                    cpcBank = 0xC3;
                }

                // add 4 bytes to center the text
                cpcAddress += 4;

                //z80 += "\tdb &" + cpcBank.ToString("X2") + ":dw &" + cpcAddress.ToString("X4") + " ;; Offset=" + iOffset + " Page=" + r12r13.PageIndex + " Line=" + r12r13.LineIndex + " VLC=" + r12r13.VLCIndex + " ScreenPtr=&" + r12r13.CPCAddress.ToString("X4") + "\n";
                z80_0 += "\tdb &" + cpcBank.ToString("X2") + "\n";
                z80_1 += "\tdb &" + (cpcAddress&255).ToString("X2") + "\n";
                z80_2 += "\tdb &" + (cpcAddress >> 8).ToString("X2") + "\n";
                
                iOffset++;
            }
            File.WriteAllText(z80ScreenPtrFilename_0, z80_0);
            File.WriteAllText(z80ScreenPtrFilename_1, z80_1);
            File.WriteAllText(z80ScreenPtrFilename_2, z80_2);
        }
    }
}
