﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;
using System.IO;
using phX.Framework;

namespace phX.Parts
{
    public class _Launcher
    {
        public _Launcher()
        {
            try
            {
                WriteImage("Launcher\\", "RatedM.png");
            }
            catch (Exception e)
            {
                Log.Fatal(e.ToString());
            }
        }

        private void WriteImage(string folder, string filename)
        {
            var bitmap = new Bitmap(Program.ToDataFolder(folder+filename));
            var image = Framework.Image.CreateImage(new Framework.Image.CreateImageStruct
            {
                Bitmap = bitmap,
                Mode = 1,
                R1 = 17,
                R4 = 38+39,
                R9 = 3,
                StartVLC = 0,
                FirstPixelInPaletteX = 0,
                FirstPixelInPaletteY = 0
            }
            );
            var allBytes = new byte[0x800*4];
            var allBytesOffset = 0;
            foreach (var VLC in image.Pages[0].VLCs)
            {
                for(int i=0; i<VLC.CPCBytes.Length; i++)
                {
                    allBytes[allBytesOffset + i] = VLC.CPCBytes[i];
                }
                allBytesOffset += 0x800;

                File.WriteAllBytes(Program.ToZ80Folder(folder+"_"+filename + ".vlc" + VLC.Index), VLC.CPCBytes);
            }
            File.WriteAllText(
                Program.ToZ80Folder(folder+"_"+filename + ".pal.z80"),
                image.Palette.ToZ80TableString(Program.FilenameToKeyWordName(filename))
            );

            var unpackedBytes = allBytes;
            File.WriteAllBytes(Program.ToZ80Folder(folder + "_" + filename + ".bin"), unpackedBytes);

            var packer = new Packer();
            var packedBytes = packer.Convert(ref unpackedBytes);
            File.WriteAllBytes(Program.ToZ80Folder(folder+"_"+filename + ".packed"), packedBytes);

            var BBPackedBytes = BBPacker.Pack(ref unpackedBytes);
            File.WriteAllBytes(Program.ToZ80Folder(folder + "_" + filename + ".bbPacked"), BBPackedBytes);
        }
    }
}
