﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace phX.Parts
{
    public class _Music
    {
        public _Music()
        {
            try
			{
                string folder;
                string filename;
                byte[] outBytes;

                folder = "Music\\";
                filename = "YM\\Suliman_V4_8_MidClownToEnd.ym.txt";
                outBytes = new Framework.Music().Convert(Program.ToDataFolder(folder + filename));

                // patch: reduce music file size
			    outBytes = new List<byte>(outBytes).Take(0xBD00 - 0x8800).ToArray();

			    File.WriteAllBytes(Program.ToZ80Folder(folder + "_Suliman_V4_8_MidClownToEnd.ym.bin"), outBytes);
                
                folder = "Music\\";
                filename = "YM\\Suliman_V4_8_BeginToMidClown.ym.txt";
				outBytes = new Framework.Music().Convert(Program.ToDataFolder(folder+filename));
                File.WriteAllBytes(Program.ToZ80Folder(folder + "_Suliman_V4_8_BeginToMidClown.ym.bin"), outBytes);

                folder = "Music\\";
                filename = "YM\\MiddlePart_V5.ym.txt";
                outBytes = new Framework.Music().Convert(Program.ToDataFolder(folder + filename));
                File.WriteAllBytes(Program.ToZ80Folder(folder + "_MiddlePart_V5.ym.bin"), outBytes);

                folder = "Music\\";
                //filename = "YM\\Outro_V5_spd55_3.ym.txt";
			    filename = "YM\\Outro_V6_2.ym.txt";
                outBytes = new Framework.Music().Convert(Program.ToDataFolder(folder + filename));
                File.WriteAllBytes(Program.ToZ80Folder(folder + "_Outro_V6.ym.bin"), outBytes);

                var allBytes = CreateOctaveTable();
				File.WriteAllBytes(Program.ToZ80Folder(folder+"_Octave.bin"), allBytes);
			}
			catch(Exception e)
			{
				Log.Fatal(e.ToString());
			}
        }

        public byte[] CreateOctaveTable()
        {
            var octaveTable = new byte[0x800];
            for (int i = 0; i < 0x800; i++)
            {
                octaveTable[i] = 1;
            }

            int minOctave = 200000;
            int maxOctave = -1;

            for (ushort value = 0; value < 0x800; value++)
            {
                float fValue = (float)value;

                byte octave = 1;
                while (fValue >= 2.0f)
                {
                    fValue /= 1.259f;
                    octave++;
                }

                octave = (byte)(32 - octave); // reverse

                if (octave < minOctave)
                {
                    minOctave = octave;
                }
                else if (octave >= maxOctave)
                {
                    maxOctave = octave;
                }

                octaveTable[value] = (byte)octave;
            }

            return octaveTable;
        }
    }
}
