﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace phX.Parts
{
    public class _PreProcNops
    {
        public _PreProcNops()
        {
            CreateWaitNopsZ80(Program.ToZ80Folder("Framework/_PreProcNops.z80"));
        }

        private void CreateWaitNopsZ80(string filename)
        {
            var z80Content = ";; This file declares a new macro _NOPS XXX where XXX is value between 0 and 128\n";
            z80Content += ";; same as regular DS XXX,0 excepted it takes less memory\n";
            z80Content += ";; by using jr $+2/ex (sp),hl opcodes when possible\n";
			z80Content += ";; also, does not update register content!\n";
            z80Content += "\n";

            const int nbMaxNops = 128;

            string s;
            
            for (int iNop=0; iNop< nbMaxNops; iNop++)
            {
                int nbBytes = 0;

                s = "MACRO _NOPS" + iNop + "\n";

                int nops = iNop;

                while(nops>=12)
                {
                    s += "\tex (sp),hl:ex (sp),hl ;12\n";
                    nops = nops - 12;

                    nbBytes += 2;
                }

                while (nops >= 3)
                {
                    s += "\tjr $+2 ;3\n";
                    nops = nops - 3;

                    nbBytes += 2;
                }

                if (nops != 0)
                {
                    s += "\tds " + nops + ",0 ;" + nops + "\n";

                    nbBytes += nops;
                }

                s += "MEND\n\n";

                z80Content += "; " + nbBytes + " byte";

                if(nbBytes>1)
                {
                    z80Content += "s";
                }

                int savedBytes = iNop - nbBytes;
                if(savedBytes>0)
                {
                    z80Content += " (saved " + savedBytes + " byte";

                    if(savedBytes>1)
                    {
                        z80Content += "s";
                    }

                    z80Content += ")";
                }

                z80Content += "\n" + s;
            }

            {
                s = ";\n";
                s += "MACRO _NOPS value\n";

                for (int iNop = 0; iNop < nbMaxNops; iNop++)
                {
                    s += "IF value = " + iNop + "\n";
                    s += "\t_NOPS" + iNop + "\n";
                    s += "ENDIF\n";
                }

                s += "MEND\n\n";

                z80Content += s;
            }

            File.WriteAllText(filename, z80Content);
        }
    }
}
