﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace phX
{
    class Program
    {
        static void Main(string[] args)
        {
			var allTasks = new List<Task>();
            //allTasks.Add(new Task(() => { new Parts._Launcher(); }));
            //allTasks.Add(new Task(() => { new Parts._PreProcNops(); }));
            //allTasks.Add(new Task(() => { new Parts._Music(); }));
            //allTasks.Add(new Task(() => { new Parts._01_Logo(); }));
            //allTasks.Add(new Task(() => { new Parts._02_SpectrumAnalyzer(); }));
            //allTasks.Add(new Task(() => { new Parts._03_Bobs(); }));
            //allTasks.Add(new Task(() => { new Parts._05_Chessboard(); }));
            //allTasks.Add(new Task(() => { new Parts._06_Clown(); }));
            //allTasks.Add(new Task(() => { new Parts._07_Epsilon(); }));
            //allTasks.Add(new Task(() => { new Parts._08_CubeRotX(); }));
            //allTasks.Add(new Task(() => { new Parts._08_CubeRotY(); }));
            //allTasks.Add(new Task(() => { new Parts._09_SineScroll(); }));
            //allTasks.Add(new Task(() => { new Parts._10_Circle(); }));
            //allTasks.Add(new Task(() => { new Parts._11_DistoGrid(); }));
            //allTasks.Add(new Task(() => { new Parts._12_Tunnel(); }));
            //allTasks.Add(new Task(() => { new Parts._13_Freddy(); }));
            //allTasks.Add(new Task(() => { new Parts._14_DistoScroll(); }));
            //allTasks.Add(new Task(() => { new Parts._15_Condense(); }));
            //allTasks.Add(new Task(() => { new Parts._17_ThirdPartEndScreen(); }));
            //allTasks.Add(new Task(() => { new Parts._18_MultiFX(); }));
            //allTasks.Add(new Task(() => { new Parts._19_Zoom(); }));
            //allTasks.Add(new Task(() => { new Parts._20_FlipScroll(); }));
            //allTasks.Add(new Task(() => { new Parts._21_Balls(); }));

            allTasks.Add(new Task(() => { new Disc.CreateDisc(); }));
            StartTasks(allTasks);
            Log.Info("All Completed.");
        }
		
		static public string GetRootDirectory()
		{
			var path = Environment.CurrentDirectory + "\\..\\..\\..\\..\\";
			return path; 
		}

        static public string GetBinDirectory()
        {
            var path = Environment.CurrentDirectory + "\\..\\..\\..\\..\\..\\build\\";
            return path;
        }

        static public string FilenameToKeyWordName(string filename)
		{
			var fileInfo = new FileInfo(filename);
			var name =  fileInfo.Name;
			return name.ToUpper().Replace(".", "_");
		}
		
        static public string ToDataFolder(string relativePathInData)
        {
			var path = GetRootDirectory() + "Data/" + relativePathInData;

			path = path.Replace("\\", "/");

			if (Environment.OSVersion.Platform != PlatformID.Unix) 
			{
				path = path.Replace ("/", "\\");
			}

			return path;
        }

        static public string ToZ80Folder(string relativePathInZ80)
		{
			var path = GetRootDirectory() + "Z80/" + relativePathInZ80;

			path = path.Replace("\\", "/");

			if (Environment.OSVersion.Platform != PlatformID.Unix)
			{
				path = path.Replace("/", "\\");
			}

			return path;
        }

        static public string ToMemZonesFolder(string relativePathInMemZones)
        {
            var path = GetRootDirectory() + "MemZones/" + relativePathInMemZones;
            
			path = path.Replace("\\", "/");

			if (Environment.OSVersion.Platform != PlatformID.Unix)
			{
				path = path.Replace("/", "\\");
			}

            return path;
        }

        private static void StartTasks(List<Task> allTasks)
        {
            foreach (var task in allTasks)
            {
                task.Start();
            }

            int aliveCount = 0;
            do
            {
                aliveCount = allTasks.Count;

                foreach (var task in allTasks)
                {
                    if (task.IsCompleted)
                    {
                        aliveCount--;
                    }
                    else if (task.IsFaulted)
                    {
                        aliveCount--;
                    }
                }
            } while (aliveCount != 0);
        }
    }
}
