﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RVIMaker
{
    public partial class BitmapWindow : Form
    {
        FXSoftwareBase _fx;
        FrameMaker _frameMaker;

        public BitmapWindow()
        {
            InitializeComponent();
        }

        public BitmapWindow(FXSoftwareBase fx)
        {
            InitializeComponent();

            _fx = fx;
            
            _fx.SetWindow(bitmapControl.Width, bitmapControl.Height);
            _frameMaker = new FrameMaker(_fx.GetCompiledFolder(), null, bitmapControl.Width, bitmapControl.Height);
        }

        public BitmapWindow(FXSoftwareBase fx, bool disableAddFrame, int nbVlc)            
        {
            DisableAddFrame = disableAddFrame;
            NBVlc = nbVlc;

            InitializeComponent();

            _fx = fx;

            _fx.SetWindow(bitmapControl.Width, bitmapControl.Height);
            _frameMaker = new FrameMaker(_fx.GetCompiledFolder(), null, bitmapControl.Width, bitmapControl.Height); 
        }

        int frameIndex = -2;
        bool isEnded = false;
        bool isExported = false;
        bool DisableAddFrame = false;
        int NBVlc = 3;

        private void timer1_Tick(object sender, EventArgs e)
        {
            frameIndex++;
            if (frameIndex == -1)
            {
                return;
            }

            if (isEnded)
            {
                if (!isExported)
                {
                    var cpcExport = new CPCExport(_frameMaker);
                    CPCExport.nbVLC = NBVlc;
                    cpcExport.Export(_fx.GetMode());

                    isExported = true;
                }

                _fx.Draw();
                return;
            }

            isEnded = _fx.Draw();

            bitmapControl.Image = ((FXSoftwareBase)_fx).GetLastBitmap();
            bitmapControl.Invalidate();

            if (!DisableAddFrame)
            {
                _frameMaker.AddFrame(frameIndex, ((FXSoftwareBase)_fx).GetLastBitmap(), ((FXSoftwareBase)_fx).GetLastSrcY());
            }
        }
    }
}
