﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading.Tasks;
using Shared;

namespace RVIMaker
{
    public class FXPlasma : FXSoftwareBase
    {
        Bitmap bmp = null;
        Graphics g;
        int width = 0;
        int height = 0;

        public FXPlasma()
        {
        }
        
        public void SetWindow(int w, int h)
        {
            //var filename = GetSourceFolder() + "Abstract5.png";
            var filename = GetSourceFolder() + "Abstract6.png";
            bmp = new Bitmap(Image.FromFile(filename));
            width = w;
            height = h;
        }

        public int GetMode()
        {
            return 0;
        }

        public string GetCompiledFolder()
        {
            return DirHelper.SourceFolder + "Demo/FXPlasma/Compiled/";
        }

        public string GetSourceFolder()
        {
            return DirHelper.SourceFolder + "Demo/FXPlasma/Raw/";
        }

        private Bitmap LastBitmap;
        public Bitmap GetLastBitmap()
        {
            return LastBitmap;
        }

        private List<byte> LastSrcY = new List<byte>();
        public List<byte> GetLastSrcY()
        {
            return LastSrcY;
        }

        public void InitFX()
        {
        }

        private void DrawLine(int srcY, int dstY)
        {
            for(int x=0; x<bmp.Width;x++)
            {
                Color c = bmp.GetPixel(x, srcY);
                g.DrawRectangle(new Pen(c), x, dstY, 1, 1);
            }
        }

        double angle1 = 0;
        double angle2 = 0;

        int nbFrames = 80;
        int iFrame = 0;

        public bool Draw()
        {
            //bool isEnded = false;

            LastBitmap = new Bitmap(width, height, PixelFormat.Format24bppRgb);
            g = Graphics.FromImage(LastBitmap);

            double FrameSin1 = Math.PI * angle1 / 180.0;
            double FrameSin2 = Math.PI * angle2 / 180.0;

            double Delta = (double)(360.0f / (float)(nbFrames));
            angle1 += Delta;
            angle2 += Delta;

            double maxY = 251.0f;

            for (int y = 0; y < height; y++)
            {
                var s1 = Math.Sin(FrameSin1);
                var s2 = Math.Cos(FrameSin2);

                FrameSin1 += 0.035f;
                FrameSin2 += 0.029f;

                double srcY = (((maxY / 2) - 1) * s1);
                srcY -= (((maxY / 2) - 1) * s2);

                while(srcY<0)
                {
                    srcY += 251;
                }
                while(srcY>=251)
                {
                    srcY -= 251;
                }

                DrawLine((int)srcY, y);
            }

            iFrame++;
            return (iFrame==nbFrames);
        }
    }
}
