﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Imaging;
using System.Threading.Tasks;
using System.IO;
using Shared;
using ImageMaker;

namespace RVIMaker
{
    public partial class FXTunnel : FXSoftwareBase
    {
        public void InitFX()
        {
            var imageFilename = "Bars5_1.png";
            var image = Image.FromFile(GetSourceFolder() + imageFilename);
            VerticalBar = new Bitmap(image);

            ImageMaker.ImageMaker.CreateMode0Raw(
                GetSourceFolder(),
                GetCompiledFolder(),
                imageFilename,
                2 //1 // skip 2 first pens in palette - BLACK is in bitmap at 0,0 but we will skip it too
                );

            barCPCBytes = File.ReadAllBytes(GetCompiledFolder() + "_"+imageFilename + ".cpcRaw");

            barWidth = (image.Width / NbBarsInBitmap);
            barCPCWidthMode0 = (barWidth) / 2;
            
            if((NbVerticalStepsInBitmap*SizeVerticalStepInBitmap)!=image.Height)
            {
                System.Diagnostics.Debugger.Break();
            }

            InitTunnelMovement();
        }
    }
}
