﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.IO;
using System.Windows.Forms;
using SharpGL;

namespace RVIMaker
{
    public partial class GLWindow : Form
    {
        public GLWindow()
        {
            InitializeComponent();
        }

        public GLWindow(FXOpenGLBase fx)
        {
            InitializeComponent();

            _fx = fx;
        }

        OpenGL _gl;
        FXOpenGLBase _fx;
        FrameMaker _frameMaker;

        private void openGLControl_OpenGLInitialized(object sender, EventArgs e)
        {
            _gl = openGLControl.OpenGL;            
        }

        private void openGLControl_Resized(object sender, EventArgs e)
        {
        }

        int frameIndex = -2;
        bool isEnded = false;
        bool isExported = false;

        private void openGLControl_OpenGLDraw(object sender, RenderEventArgs e)
        {
            frameIndex++;
            if (frameIndex==-1)
            {
                _fx.SetGL(_gl, Width, Height);

                if (_fx.GetMode() == 1)
                {
                    openGLControl.Width *= 2;
                }
                else if (_fx.GetMode() == 2)
                {
                    openGLControl.Width *= 4;
                }

                _frameMaker = new FrameMaker(_fx.GetCompiledFolder(), _gl, openGLControl.Width, openGLControl.Height);

                return;
            }

            if (isEnded)
            {
                if (!isExported)
                {
                    var cpcExport = new CPCExport(_frameMaker);
                    cpcExport.Export(_fx.GetMode());

                    isExported = true;
                }

                _fx.Draw();
                return;
            }

            isEnded = _fx.Draw();

            _frameMaker.AddFrame(frameIndex);
        }
    }
}
