﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;
using Shared;

namespace ImageMaker
{
	public static class GradientMaker
	{
		public static void Create(
			string rawFolder, 
			string compiledFolder, 
			string rawDataFilename, 
			string paletteFilename)
		{
			var allBytes = File.ReadAllBytes(rawFolder+rawDataFilename);
			var firmwarePalette = File.ReadAllBytes(rawFolder+paletteFilename);

			var colorTable = "";
			foreach(var iByte in allBytes)
			{
				byte p0_0 = (byte)((iByte >> 7)&1);
				byte p0_2 = (byte)((iByte >> 5) & 1);
				byte p0_1 = (byte)((iByte >> 3) & 1);
				byte p0_3 = (byte)((iByte >> 1) & 1);

				int index = (p0_0) + (p0_1 << 1) + (p0_2 << 2) + (p0_3 << 3);

				var color = firmwarePalette[index];

				colorTable += "\tdb COLOR" + color + "\n";
			}

			DirHelper.CreateDirectory(compiledFolder);
			File.WriteAllText(compiledFolder+rawDataFilename+".raster.z80", colorTable);
		}
	}
}
