﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace Shared
{
    public static class BitmapHelper
    {
        public static Bitmap DivideWidthBy2IfNecessary(ref Bitmap bitmap)
        {
            bool isDoubled = true;

            for (int x = 0; x < bitmap.Width; x += 2)
            {
                if ((x + 1) < bitmap.Width)
                {
                    if (bitmap.GetPixel(x, 0) != bitmap.GetPixel(x + 1, 0))
                    {
                        isDoubled = false;
                    }
                }
            }

            if (!isDoubled)
            {
                return bitmap;
            }

            Bitmap result = new Bitmap(bitmap.Width / 2, bitmap.Height);
            using (Graphics g = Graphics.FromImage(result))
            {
                g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.NearestNeighbor;

                g.DrawImage(bitmap, 0, 0, bitmap.Width / 2, bitmap.Height);
            }

            return result;
        }
    }
}
