﻿using System;
using System.IO;
using System.Reflection;

namespace Shared
{
	public static class DirHelper
	{
		private static string _rootFolder = "";
		public static string SourceFolder { 
			get
			{
				if(_rootFolder.Length==0)
				{
					_rootFolder = Environment.CurrentDirectory + "\\..\\..\\..\\..\\..\\";
                }
				return _rootFolder;
			}
		}

		public static string GetBinaryFullName(string relativePath, string binaryFilename)
		{
			var fullPath = DirHelper.SourceFolder + relativePath;

			var osVersion = System.Environment.OSVersion;
			if(osVersion.VersionString.Contains("Microsoft"))
			{
				binaryFilename += ".exe";
			}

			return fullPath + binaryFilename;
		}

		public static string FormatDirectory(string dirFullName)
		{
			if(dirFullName[dirFullName.Length-1]=='/')
			{
				dirFullName = dirFullName.Substring(0, dirFullName.Length-1);
			}

			return dirFullName;
		}

		public static void CreateDirectory(string dirFullName)
		{
			Directory.CreateDirectory(FormatDirectory(dirFullName));
		}
	}
}
